use crate::data_toml;
use crate::url;
use crate::http_client::HttpClient;
use iso8601_timestamp::Timestamp;
use serde_json::json;

pub async fn post_request(
    text: String,
    cid: String,
    uri: String,
    cid_root: String,
    uri_root: String,
) -> String {
    let did = data_toml(&"did");
    let handle = data_toml(&"handle");

    let url = url(&"record_create");
    //let url = "https://bsky.social/xrpc/com.atproto.repo.createRecord";
    let col = "app.bsky.feed.post".to_string();

    let d = Timestamp::now_utc();
    let d = d.to_string();

    let post = json!({
        "repo": handle.to_string(),
        "did": did.to_string(),
        "collection": col.to_string(),
        "record": {
            "text": text.to_string(),
            "createdAt": d.to_string(),
            "reply": {
                "root": {
                    "cid": cid_root.to_string(),
                    "uri": uri_root.to_string()
                },
                "parent": {
                    "cid": cid.to_string(),
                    "uri": uri.to_string()
                }
            }
        },
    });

    let client = HttpClient::new();
    match client.post_json_with_auth(&url, &post).await {
        Ok(response) => response,
        Err(e) => {
            eprintln!("Error replying to post: {}", e);
            "err".to_string()
        }
    }
}
